Bug 180017 - gdm greeter should paint theme background image on auxillary heads in multihead setups.
gdm greeter should paint theme background image on auxillary heads in multihe...
Product: Fedora
Classification: Fedora
Component: gdm (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ray Strode [halfline]
Mike McLean
Depends On:
  Show dependency treegraph
Reported: 2006-02-04 13:48 EST by Ulrich Drepper
Modified: 2009-01-09 01:55 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-01-09 01:55:35 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Ulrich Drepper 2006-02-04 13:48:40 EST
Description of problem:
Ever since the last big revamp of the login screen about 2-3 weeks ago the
second screen on my system (using NVidia's proprietary driver because nv does
not  have twinview support) leaves the second screen black.  This wasn't the
case before.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1.get nvidia card with twinview support (mine is Quadro FX 330)
2.start system at runlevel 5
Actual results:
second screen black

Expected results:
background (at least) should be on both screens

Additional info:
xdpyinfo shows the two screens as one big one

screen #0:
  print screen:    no
  dimensions:    3200x1200 pixels (821x311 millimeters)
  resolution:    99x98 dots per inch
  depths (7):    16, 1, 4, 8, 15, 24, 32
  root window id:    0x5c
  depth of root window:    16 planes

In /etc/X11/xorg.conf one specifies it like this:

Section "Screen"
    Identifier     "Screen0"
    Device         "Videocard0"
    Monitor        "Monitor0"
    DefaultDepth    16
    Option         "TwinView" "yes"
    Option         "TwinViewOrientation" "RightOf"
    Option         "MetaModes" "1600x1200,1600x1200"
Comment 1 Ray Strode [halfline] 2006-02-04 19:25:07 EST

Recently we changed from making the default background color be blue to black.
I'm wondering if that's what you're seeing here?

If you move your mouse to the black screen can you see a cursor?
Comment 2 Ulrich Drepper 2006-02-04 19:39:02 EST
What I see is that one screen has the blue background and gdm graphics and the
other one is black.  The mouse pointer is visible at either one.

One strange thing: when the mouse is on the black screen the gdm input widget
does not have focus.  That by itself is highly annoying because it means I
always have to use the mouse and move it into the screen with the input field
because somehow it is by default in the midel but just in the black screen.
Comment 3 Ray Strode [halfline] 2006-02-04 20:11:48 EST
GDM currently only uses one head in multihead setups.  The question is what do
we do with the other head?  Before the theme redesign we just painted it blue. 
This worked okay because the theme itself was blue.  The new theme has a brushed
metal gradient, so painting the other head blue breaks the continuity and
previously confused some users.  Thos users assumed something would eventually
load in the blank blue head.

Recently, we changed it from blue to black.  The rationale being that we aren't
using the head so let's make it look inactive.  What you're seeing (one screen
black and one screen active) is by design.  

It's obviously confused you, so the design might need some rethinking.  I'm not
entirely sure what the correct behavior should be, however.  We don't want to
stretch the login screen over all the heads.  That would look horrible, and
probably break a lot of 3rd party themes.

I think maybe we should just put the brushed metal background up on the second
head so it seems more like an extension of the theme.  Or maybe we should put
some sort of explanatory text saying to log in using the main head?  Maybe a big
arrow pointing to the right head with the text "Login here -->"?

Comment 4 Ulrich Drepper 2006-02-04 22:45:55 EST
The new behavior is defintely rritation because it's different from the old
behavior.  And I'm certainly not the worst critic when it comes to this.  Less
technical people are even less inclined to accept change (ask my wife).

The old behavior probably wasn't perfect.  But it at least showed the second
screen was recognized properly.

I always though why not present the information on both screen.  Maybe even
magically fill in the information entered into the field on the one screen into
the edit field on the other screen.  Then it wouldn't matter which screen is
used and where the mouse cursor happens to be.

Alternatively using the brushed background is certainly much better than the
current behavior.
Comment 5 Ray Strode [halfline] 2006-02-05 01:02:46 EST
While cloning may give a more consistent experience to the user (because before
X starts the console is cloned), I think it would be hard to get right.  We
can't turn on real cloning after the X server has started, so we would have to
emulate it by proxying key events, clicks, and presenting a fake second mouse
cursor, etc.  It would also be inconsistent if the heads had different resolutions.

We might be able to get most of the way there by making the greeter model-view
or something along those lines, but all in all it would be a pretty significant
engineering effort.  It would definitely take more resources to do than value
added over the alternative you mention--putting the brushed gradient background
up. So, I think we should just do that.
Comment 6 Ulrich Drepper 2006-02-05 02:53:39 EST
I agree with this, it's a lot of work.  I'm not sure it's necessary to mimic the
mouse cursor the same way (just one would be fine).

Anyway, for the solution of painting the theme on the second screen: the
keyboard focus is still a problem.  I really would prefer to not having to use
the mouse before I type in the user ID and password.  But with the current setup
the mouse cursor for me ends up on the second, black screen and the input line
does not have focus.

Couldn't at least this be fixed?
Comment 7 Ray Strode [halfline] 2006-02-05 03:12:48 EST
So the problem is that there is no window manager running.  This means that
windows only get focus when the mouse is over them.

It should be fixable though.  Can you file a separate bug report and add it to
the  FC5Target tracker?

Comment 8 Ray Strode [halfline] 2006-02-06 01:13:11 EST
For the record, the issue mentioned in comment 6 (and the second paragraph of
comment 2) has been entered as bug 180085.
Comment 9 Matthias Clasen 2006-02-06 16:02:34 EST
Ray, can't you just set the keyboard focus to the greeter window explicitly ?
Comment 10 Ray Strode [halfline] 2006-02-06 19:20:13 EST
Matthias, yes we should be able to do that.
Comment 11 Bug Zapper 2008-11-26 01:54:49 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 12 Bug Zapper 2009-01-09 01:55:35 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.